#include <iostream>
#include <cmath>
#include <vector>
#include <windows.h>
#include <queue>

using namespace std;

struct Cast {
    vector<int> &arr_a;
    vector<int> &arr_b;
    int k;
    int count;
    vector<int> pref;
    int startIa;
    int startIb;
};

int find(vector<int> &arr, int clue, int start = 0) {
    if (start == -3) return -3;
    for (int i = start; i < arr.size(); ++i) {
        if (arr[i] == clue) {
            return i;
        }
    }
    return -3;
}

void cleverFind(Cast cast, queue<Cast> &queue) {
    if (cast.startIa == -3 && cast.startIb == -3) {
        cout << cast.pref.size() << endl;
        for (int i : cast.pref) {
            cout << i << ' ';
        }
        cout << endl;
        exit(0);
    }

    if (cast.count == 0) return;

    for (int i = 1; i <= cast.k; ++i) {
        cast.pref.push_back(i);
        queue.push(Cast{cast.arr_a, cast.arr_b, cast.k, cast.count - 1, cast.pref,
                        cast.startIa == -3 ? -3 : find(cast.arr_a, i, cast.startIa + 1),
                        cast.startIb == -3 ? -3 : find(cast.arr_b, i, cast.startIb + 1)});
        cast.pref.pop_back();
    }
}

int main() {
    int k, m, n;
    cin >> k >> m;

    vector<int> arr_a, arr_b;
    bool *used = new bool[k];
    memset(used, 0, k);
    {
        int in;
        for (int i = 0; i < m; ++i) {
            cin >> in;
            used[in - 1] = true;
            arr_a.push_back(in);
        }
        cin >> n;
        for (int i = 0; i < m; ++i) {
            cin >> in;
            used[in - 1] = true;
            arr_b.push_back(in);
        }
    }

    if (k == 1) {
        cout << max(n, m) + 1 << endl;
        for (int q = 0; q < max(n, m) + 1; ++q) {
            cout << "1 ";
        }
        cout << endl;
        return 0;
    }

    queue<Cast> queue;
    queue.push(Cast{arr_a, arr_b, k, n + m, vector<int>(), -1, -1});
    while(queue.size()) {
        cleverFind(queue.front(), queue);

        queue.pop();
    }

    return 0;
}
