import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main4 {

    public static void main(String[] args) {
	    Scanner s = new Scanner(System.in);
	    long l = s.nextInt(), r = s.nextInt();
        long count = 0;
        List<Long> frees = new ArrayList<>();
        for (long i = l; i <= r; i++) {
            if (isFree(i)) frees.add(i);
        }
        List<LongEntry> entries = new ArrayList<>();
        for (Long free_a : frees) {
            for (Long free_b : frees) {
                if (free_b.equals(free_a)) continue;
                if (isFree(free_a*free_b)) {
                    LongEntry ent = new LongEntry(free_a, free_b);
                    if (!entries.parallelStream().anyMatch(e -> e.equals(ent))) {
                        entries.add(ent);
                    }
                }
            }
        }
        System.out.println(entries.size());
        System.out.flush();
    }

    private static boolean isFree(long i) {
        if (i < 5 && i != 4) return true;
        long maxFind = (long) (Math.sqrt(i) + 1);
        for (long t = 2; t <= maxFind; t++) {
            if ((i % (t*t)) == 0) {
                return false;
            }
        }
        return true;
    }

    public static class LongEntry {
        public final long a, b;
        public LongEntry( long a, long b) {
            this.a = Math.max(a, b);
            this.b = Math.min(a, b);
        }

        @Override
        public boolean equals(Object obj) {
            LongEntry ent = (LongEntry) obj;
            return ent.a == this.a && ent.b == this.b;
        }
    }
}
