#include <iostream>
#include <algorithm>
#include <string>
#include <array>

using namespace std;

using ll = long long;

constexpr bool isPrime(int n){
    for(int i = 2; i * i <= n; i++){
        if (n % i == 0)
            return false;
    }
    return true;
}

constexpr auto getPrimes() {
    array<int, 9592> primes{};
    int primeNum = 0;
    for(int i = 2; primeNum < 9592; i++){
        if (isPrime(i)){
            primes[primeNum] = i;
            primeNum++;
        }
    }
    return primes;

}
constexpr auto primes2 = getPrimes();

bool isSimpleSquareFree(ll n){
    return true;
}
bool isSquareFree(ll n){
    for (int prime : primes2){
        if (n % prime == 0){
            n /= prime;
            if (n % prime == 0)
                return false;
        }
        if (n < prime * prime)
            return true;
    }
    return true;
}

int main()
{
    ll l, r;
    ll cnt = 0;
    cin >> l >> r;
    for (ll i = l; i < r; i++){
        for (ll j  = i + 1; j <= r; j++){
            if (isSimpleSquareFree(i) && isSimpleSquareFree(j)){
                if (__gcd(i, j) != 1)
                    continue;
                if (isSquareFree(i) && isSquareFree(j)){
                    cnt++;
                }
                //cout << i << " " << j << endl;
            }
        }
    }
    cout << cnt ;
}
