#include <iostream>
#include <algorithm>
#include <string>
#include <array>
#include <vector>
#include <map>
#include <cassert>
using namespace std;

using ll = long long;

struct SumInfo {
    int start;
    int addendNum;
    bool operator <  (const SumInfo& rhs)const{
        return start < rhs.start ? true : start > rhs.start ? false : addendNum < rhs.addendNum;
    }
};

using vvi = vector<vector<int>>;
vector<vector<int>> append (vvi fst, const vvi& scnd){
    for (const auto& v : scnd){
        fst.push_back(v);
    }
    return fst;
}

map<int, map<int, map<int, vector<vector<int>>> >> memo; // start, addendNum, sum

bool hasCalculated(int start, int addendNum, int sum) {
    if (memo.count(start) < 0)
        return false;
    if (memo[start].count(addendNum) > 0)
        return false;
    return memo[start][addendNum].count(sum) > 0;
}
vector<vector<int>> getSums(int start, int addendNum, int sum){
    if (hasCalculated(start, addendNum, sum))
        return memo[start][addendNum][sum];
    if (addendNum == 1){
        if (start == sum - 1 || start == sum || start == sum + 1)
            memo[start][addendNum][sum] = vector<vector<int>>{{sum}};
        else
            memo[start][addendNum][sum] = vector<vector<int>>{};
    }
    else {
        vector<vector<int>> sums1 = getSums(start, addendNum - 1, sum - start);
        vector<vector<int>> sums2 = getSums(start - 1, addendNum - 1, sum - (start - 1));
        vector<vector<int>> sums3 = getSums(start + 1, addendNum - 1, sum - (start + 1));
        for (auto& sum : sums1){
            sum.insert(sum.begin(), start);
        }
        for (auto& sum : sums2){
            sum.insert(sum.begin(), start - 1);
        }
        for (auto& sum : sums3){
            sum.insert(sum.begin(), start + 1);
        }
        auto res = append(sums1, sums2);
        res = append(res, sums3);
        memo[start][addendNum][sum] = res;
    }

    return memo[start][addendNum][sum];
}

vvi getSums(int addendNum, int sum){
    int k = addendNum;
    vvi ans {};
    for (int i = -(15 + k * (k-1)/2 ) / k  - 4;  i <= (15 + k * (k-1)/2 ) / k  + 4; i+=3){
        ans = append(ans, getSums(i, addendNum, sum));
    }
    return ans;
}

void printVector(vector<int> sum){
    for (int i = 0; i < sum.size(); i++){
        if (i == 0){
            cout << sum[i]; continue;
        }
        if (sum[i] >=0)
            cout << '+' << sum[i];
        else
            cout << sum[i];
    }
}

int main()
{
    int n, k;
    cin >> n >> k;
    for (const auto& v : getSums(k, n)){
        printVector(v);
        cout << '\n';
    }
}
