#include <iostream>
#include <vector>
#include <cmath>

template<class T>
bool is_square_free (T x) {
    T lst = (T)sqrt((long double)x);
    for (T i = 2; i <= lst; ++i)
        if (x % i == 0 && (x / i) % i == 0)
            return false;
    return true;
};

int main () {
    using namespace std;
    using int64 = long long;
    
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    
    int l, r;
    cin >> l >> r;
    
    vector<int> square_free;
    for (int i = l; i <= r; ++i)
        if (is_square_free(i))
            square_free.push_back(i);
    
    int cnt = 0;
    auto lim = end(square_free);
    for (auto it = begin(square_free); it < lim; ++it)
        for (auto jt = next(it); jt < lim; ++jt)
            if (is_square_free((int64)*it * (int64)*jt))
                ++cnt;
    
    cout << cnt << '\n';
    
    return 0;
}