#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

vector<int> get_fixed_factorized(int n)
{
    vector<int> null = {};
    vector<int> res = {};
    if (n == 1)
    {
        res.push_back(1);
        return res;
    }

    int saved_n = n;
    int i_c = 0;
    while (n % 2 == 0)
    {
        if (i_c >= 1)
            return null;
        res.push_back(n);
        n /= 2;
        i_c += 1;
    }
    for (int i = 3; i < sqrt(n) + 1; i += 2)
    {
        i_c = 0;
        while (n % i == 0)
        {
            if (i_c >= 1)
                return null;
            res.push_back(i);
            n /= i;
            i_c += 1;
        }
    }
    if (n > 1)
        res.push_back(n);

    return res;
}

int is_intercepting(vector<int> a, vector<int> b)
{
    for (int ia = 0; ia < a.size(); ia++)
    {
        for (int ib = 0; ib < b.size(); ib++)
        {
            if (a[ia] == b[ib])
            {
                return true;
            }
        }
    }
    return false;
}

int main()
{
    int l, r;
    cin >> l >> r;
    int counter = 0;
    for (int b = l + 1; b < r + 1; b++)
    {
        vector<int> b_factors = get_fixed_factorized(b);
        if (b_factors.size() == 0)
            continue;
        for (int a = l; a < b; a++)
        {
            vector<int> a_factors = get_fixed_factorized(a);
            if (a_factors.size() == 0)
                continue;
            if (!is_intercepting(a_factors, b_factors))
                counter++;
        }
    }
    cout << counter << endl;
    return 0;
}