//@author : Kirkon
//current CF rating: 1605

#include <iostream>
#include <vector>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <string>
#include <cstring>
#include <cstdio>
#include <algorithm>

using namespace std;

#define all(x) (x).begin(), (x).end()

typedef long long ll;

template<class T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> a;
    }
    return in;
}

int gcd(int a, int b) {
    //a >= b
    if (b == 0) {
        return a;
    }
    if (b == 1) {
        return 1;
    }
    return gcd(b, a % b);
}

void solve() {
    //у квадрата нечетное число делителей
    //можно факторизовать число за корень и посмотреть на степень вхождения всех простых, не должно быть ни одного чётного числа
    //потом нужно смёржить две факторизации и посмотреть что степень вхождения всех простых по прежнему нечётна
    //если был хоть один общий простой, значит его степень вхождения после объединения точно станет чётна значит НОД(gcd) чисел a и b = 1
    int l, r;
    cin >> l >> r;
    vector<bool> isgood(r - l + 1, true);
    for (int i = l; i <= r; ++i) {
        for (int j = 2; j * j <= i; ++j) {
            if (i % (j * j) == 0) {
                isgood[i - l] = false;
                break;
            }
        }
    }
    //Цикл занимает порядка (r - l + 1) * sqrt(10^9) ~ 1000 * 10^5 быстро
    int ans = 0;
    for (int i = l; i < r; ++i) {
        for (int j = i + 1; j <= r; ++j) {
            if (isgood[i - l] && isgood[j - l]) {
                if (gcd(i, j) == 1) {
                    //cout << i << " " << j << endl;
                    ++ans;
                }
            }
        }
    }
    cout << ans << endl;
    return;
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}