#include <iostream>
#include <string>
#include <math.h>
#include <queue>
#include <assert.h>
#include <set>
#include <bitset>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <algorithm>
#include <iomanip>
#include <unordered_set>
#include <complex>

using namespace std;

#define ll long long
#define vii vector<int>
#define vll vector<ll>
#define pii pair<int, int>
#define pll pair<ll, ll>
#define pdd pair<double, double>
#define pbb pair<bool, bool>
#define pb push_back
#define f first
#define s second
#define vpii vector<pii >
#define ld long double
#define vbb vector<bool>
#define vdd vector<double>
#define vpll vector<pll >

ostream &operator<<(ostream &os, const vll &a)
{
    for (int i = 0; i < a.size(); i++)
        os << a[i] << " ";
    return os;
}

#define inf (unsigned short)(10000)

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(30);

#ifdef LOCAL
    freopen("Input.txt", "r", stdin);
    freopen("Output.txt", "w", stdout);
#endif

    ll k;
    cin >> k;

    ll m;
    cin >> m;
    vll a(m);
    for(int i = 0; i < m; i++)
        cin >> a[i];

    ll n;
    cin >> n;
    vll b(n);
    for(int i = 0; i < n; i++)
        cin >> b[i];

    vector<vll > posesA(k + 1);
    vector<vll > posesB(k + 1);

   // cerr << "before reading poses" << endl;
    //cerr << a << endl;
   // cerr << posesA.size() << endl;
   // cerr << b << endl;
  //  cerr << posesB.size() << endl;
    for(int i = 0; i < m; i++)
        posesA[a[i]].pb(i);
    for(int i = 0; i < n; i++)
        posesB[b[i]].pb(i);

  //  cerr << "after reading poses" << endl;
    vector<vector<unsigned short> > dp(m + 1, vector<unsigned short>(n + 1, inf));
    vector<vector<pair<unsigned short, unsigned short> > > prev(m + 1, vector<pair<unsigned short, unsigned short> > (n + 1, {-1, -1}));

   // dp[0][0] = 0;

    ll mnAnsw = inf;
    pair<unsigned short, unsigned short> prevPos = {-1, -1};
    ll lastChar = -1;

   // cerr << "before working with dp" << endl;
    for(int t = 1; t <= k; t++)
    {
        ll newI = (posesA[t].size() == 0 ? m : posesA[t][0]);
        ll newJ = (posesB[t].size() == 0 ? n : posesB[t][0]);

        if (dp[newI][newJ] > 1)
        {
            dp[newI][newJ] = 1;
            prev[newI][newJ] = {inf, inf};

            if ((newI == m && newJ == n) && (mnAnsw > dp[newI][newJ]))
            {
                mnAnsw = dp[newI][newJ];
                prevPos = {inf, inf};
                lastChar = t;
            }
        }
    }

  /*  for(int i = 0; i <= n; i++)
    {
        for(int j = 0; j <= m; j++)
            cerr << dp[i][j] << " ";
        cerr << endl;
    }
*/
    vll pointersA(k + 1, 0);
    for(int i = 0; i <= m; i++)
    {
        vll pointersB(k + 1, 0);
        for(int j = 0; j <= n; j++)
        {
            if(dp[i][j] >= mnAnsw)
                continue;
       //     cerr << "i " << i << " j " << j << " dp[i][j] " << dp[i][j] << endl;
            for(int t = 1; t <= k; t++)
            {
                while(pointersA[t] < posesA[t].size() && posesA[t][pointersA[t]] <= i)
                    pointersA[t]++;
                while(pointersB[t] < posesB[t].size() && posesB[t][pointersB[t]] <= j)
                    pointersB[t]++;

                ll newI = (pointersA[t] >= posesA[t].size() ? m : posesA[t][pointersA[t]]);
                ll newJ = (pointersB[t] >= posesB[t].size() ? n : posesB[t][pointersB[t]]);

//                cerr << "t " << newI << " " << newJ << endl;
                if(dp[newI][newJ] > dp[i][j] + 1)
                {
                    dp[newI][newJ] = dp[i][j] + 1;
                    prev[newI][newJ] = {i, j};

                    if((newI == m && newJ == n) && (mnAnsw > dp[newI][newJ]))
                    {
                        mnAnsw = dp[newI][newJ];
                        prevPos = {i, j};
                        lastChar = t;
                    }
                }
            }
        }
    }
   // cerr << "mn answ " << mnAnsw << endl;
    vector<ll> answer;
    answer.pb(lastChar);

    //cerr << "finishPair " << prevPos.f << " " << prevPos.s << " lastChar " << lastChar << endl;
    pair<unsigned short, unsigned short> finishPair = {inf, inf};
    while(prevPos != finishPair)
    {
        if(prevPos.f >= m && prevPos.s >= n)
            answer.pb(1);
        else if(prevPos.f < m)
            answer.pb(a[prevPos.f]);
        else
            answer.pb(b[prevPos.s]);
        prevPos = prev[prevPos.f][prevPos.s];
      //  cerr << "newPrev pos " << prevPos.f << " " << prevPos.s << endl;
    }
    reverse(answer.begin(), answer.end());
    cout << answer.size() << "\n";
    cout << answer << endl;
    return 0;
}