﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

bool check(vector<int>& v1, vector<int>& v2)
{
	if (v1.size() > v2.size()) return false;
	int j = 0;
	for (int i = 0; i < v1.size(); ++i)
	{
		while (j < v2.size() && v2[j] != v1[i]) ++j;
		if (j >= v2.size()) return false;
		++j;
	}
	return true;
}

vector<int> v1, v2;
vector<string> ans;

void search(int n, int k, vector<int> &v)
{
	if (n > 0 && !check(v, v1) && !check(v, v2) && ans[n].empty()) {
		for (int j : v) ans[n] += to_string(j) + " ";
	}
	if (n > max(v1.size(), v2.size())) return;
	for (int i = 1; i <= k; ++i) {
		v.push_back(i);
		search(n + 1, k, v);
		v.pop_back();
	}
}

int main()
{
	int k, n, m;
	cin >> k >> m;
	vector<bool> fr(k, true);
	vector<int> vm(m);
	for (int i = 0; i < m; ++i) 
	{
		cin >> vm[i];
		fr[vm[i] - 1] = false;
	}
	cin >> n;
	vector<int> vn(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> vn[i];
		fr[vn[i] - 1] = false;
	}
	for (int i = k - 1; i >= 0; --i)
		if (fr[i])
		{
			cout << "1\n" << i + 1;
			return 0;
		}
	if (k == 1)
	{
		cout << max(n, m) + 1 << '\n';
		for (int i = 0; i < max(n, m) + 1; ++i) cout << k << ' ';
		return 0;
	}
	v1 = vm, v2 = vn;
	ans.resize(max(v1.size(), v2.size()) + 2);
	vector<int> vv;
	search(0, k, vv);
	for(int i = 0; i < ans.size(); ++i)
		if (!ans[i].empty()) {
			cout << i << '\n' << ans[i];
			return 0;
		}
}