#include <bits/stdc++.h>

namespace {
    using namespace std;
#define int long long

    template<typename T>
    inline bool whitespace(const vector<T> &) { return false; }

    template<typename T>
    inline bool whitespace(const T &) { return true; }

    inline bool whitespace(const char) { return false; }

    template<typename F, typename S>
    inline bool whitespace(const pair<F, S> &) { return false; }

    template<typename F, typename S>
    ostream &operator<<(ostream &os, const pair<F, S> &p) {
        os << p.first << (whitespace(p.second) ? " " : "") << p.second << "\n";
        return os;
    }

    template<typename F, typename S>
    istream &operator>>(istream &is, pair<F, S> &p) {
        is >> p.first >> p.second;
        return is;
    }

    template<typename T>
    istream &operator>>(istream &is, vector<T> &v) {
        for (T &t : v) is >> t;
        return is;
    }

    template<typename T>
    ostream &operator<<(ostream &os, const vector<T> &v) {
        for (const T &t : v) os << t << (whitespace(t) ? " " : "");
        os << "\n";
        return os;
    }

    template<typename T>
    istream &operator>>(istream &is, deque<T> &v) {
        for (T &t : v) is >> t;
        return is;
    }

    template<typename T>
    ostream &operator<<(ostream &os, const deque<T> &v) {
        for (const T &t : v) os << t << (whitespace(t) ? " " : "");
        os << "\n";
        return os;
    }

    class exit_exception : exception {
    };

    void answer() {}

    template<typename First, typename... Args>
    void answer(First &&val, Args &&... ans) {
        cout << val << "\n";
        answer(ans...);
        throw exit_exception();
    }

    struct autoint {
        int x;

        autoint(int i) : x(i) {}

        autoint() { cin >> x; }

        operator int() { return x; }

        int operator--() { return --x; }

        int operator--(signed) { return x--; }

        int operator++() { return ++x; }

        int operator++(signed) { return x++; }
    };
}

void solve();

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    do { try { solve(); } catch (exit_exception &) {}} while (--t);
    return 0;
}

vector<vector<int>> next(const vector<int> &a, int k) {
    auto next = vector<vector<int>>(a.size() + 1, vector<int>(k, a.size()));
    for (int i = a.size() - 1; i >= 0; --i) {
        for (int c = 0; c < k; ++c) next[i][c] = next[i + 1][c];
        if (i + 1 < a.size()) next[i][a[i + 1]] = i + 1;
    }
    return next;
}

void fanswer(vector<vector<int>> parent, vector<vector<int>> value, int times, int i) {
    auto c = vector<int>(times);
    for (int stage = times - 1; stage >= 0; --stage) {
        i = parent[stage][i];
        c[stage] = value[stage][i];
    }
    cout << c.size() << '\n' << c;
}

void solve() {
    autoint k;
    autoint n;
    vector<int> a(n);
    cin >> a;
    for (int &x : a)--x;
    a.insert(a.begin(), 0);
    autoint m;
    vector<int> b(m);
    cin >> b;
    for (int &x : b)--x;
    b.insert(b.begin(), 0);
    auto nextA = next(a, k);
    auto nextB = next(b, k);

    auto index = vector<vector<int>>(a.size() + b.size() + 1, vector<int>(a.size() + 1, -1));
    auto parent = vector<vector<int>>(a.size() + b.size() + 1, vector<int>(a.size() + 1, -1));
    auto value = vector<vector<int>>(a.size() + b.size() + 1, vector<int>(a.size() + 1, -1));
    index[0][0] = 0;

    for (int times = 1; times < index.size(); ++times) {
        for (int i = 0; i < index[times].size(); ++i) {
            for (int v = 0; v < k; ++v) {
                if (index[times - 1][i] == -1) continue;
                if (index[times][nextA[i][v]] < nextB[index[times - 1][i]][v]) {
                    index[times][nextA[i][v]] = nextB[index[times - 1][i]][v];
                    parent[times - 1][nextA[i][v]] = i;
                    value[times - 1][i] = v;
                }
            }
        }
        if (index[times][a.size()] == b.size()) return fanswer(parent, value, times, a.size());
    }
}
