import kotlin.text.StringBuilder
import kotlin.math.*

fun rLine() = readLine()!!
fun rInt() = readLine()!!.toInt()
fun rLong() = readLine()!!.toLong()
fun rWords() = readLine()!!.split(" ")
fun rIntArr() = readLine()!!.split(" ").map { it.toInt() }
fun rLongArr() = readLine()!!.split(" ").map { it.toLong() }

fun main() = taskF()

fun taskA() {
    val n = rInt()
    val m = rInt()
    val min = minOf(m, n)
    val rem = n + m - 2 * min
    println(min * 2 + rem % 2)
}

fun taskB() {
    val a = rLong()
    val b = rLong()
    val k = rLong()
    for (i in a..b) println((1..minOf(i, k)).map { i * (i - 1) / 2 + it }.joinToString(" "))
}

fun taskC() {
    val rate = rInt()
    val divs = rLine()
    val is1 = '1' in divs
    val is2 = '2' in divs
    val is3 = '3' in divs
    when {
        rate <= 1600 -> { //3rd
            if (is3) return println(3)

            if (is1) println(1)
            if (is2) println(2)
        }
        rate <= 1900 -> {//2nd
            if (is2) return println(2)

            if (is1) println(1)
            if (is3) println("3*")
        }
        else -> { //1st
            if (is1) return println(1)

            if (is2) println("2*")
            if (is3) println("3*")
        }
    }
}

fun taskD() {
    val l = rInt()
    val r = rInt()
    val free = (l..r).filter { isSquareFree(it) }

//    println(free.joinToString (" "))

    var count = 0
    for (a in free) for (b in free) if (a < b && isMultiplicationSquareFree(a, b)) {
        count++
//        println("$a, $b")
    }

    println(count)
}

fun isSquareFree(i: Int) = if (i < 4) true else (2..(sqrt(i.toDouble()) + 1).toInt()).all { i % (it * it) != 0 }
//                            ^Unknown trouble with small numbers?

fun isMultiplicationSquareFree(a: Int, b: Int): Boolean {
    if (a == 1) return true
    if (a == 2) return b % 2 != 0
    //Assuming a<b, a, b is square-free
    if (b % a == 0) return false

    for (i in 2..(sqrt(a.toDouble()) + 1).toInt()) if (a % i == 0) {//For all dividers of a
        // a/i is also divider of a
        if (b % i == 0 || b % (a / i) == 0) return false
    }
    return true
}

fun taskE() {
    val n = rInt()
    val k = rInt()
    val low = ((2 * n - k * k + k + 0.0) / 2 / k).toInt() - 1
    val high = ((2 * n + k * k - k + 0.0) / 2 / k).toInt() + 1
//    println("$low, $high")
    for (start in low..high) recursivelyGenerateSequences(n, k - 1, listOf(start), start)
}

fun recursivelyGenerateSequences(n: Int, k: Int, sequence: List<Int>, sum: Int) {
//    println("rgs entered with $n, $k, [${sequence.joinToString(" ")}], $sum")

    if (k == 0 && sum == n) return printSequence(sequence)

    val last = sequence.last()
    if (abs(n - k * last - sum) > (k * (k + 1) / 2)) return

    recursivelyGenerateSequences(n, k - 1, sequence + (last - 1), sum + last - 1)
    recursivelyGenerateSequences(n, k - 1, sequence + (last), sum + last)
    recursivelyGenerateSequences(n, k - 1, sequence + (last + 1), sum + last + 1)
}

fun printSequence(sequence: List<Int>) {
    if (sequence.size == 1) return println(sequence[0])

    val sb = StringBuilder()
    sb.append(sequence[0])
    for (i in 1 until sequence.size) {
        if (sequence[i] >= 0) sb.append("+")
        sb.append(sequence[i])
    }

    println(sb.toString())
}

fun taskF() {
    val k = rInt()
    val aLen = rInt()
    val aArr = rIntArr()
    val bLen = rInt()
    val bArr = rIntArr()
    val max = max(aLen, bLen)
    for (p in 1..max) {
        if (searchAndPrintSequence(p, aArr, bArr, k)) return
    }
    println("1 ".repeat(max + 1))
}

fun searchAndPrintSequence(p: Int, aArr: List<Int>, bArr: List<Int>, k: Int, sequence: List<Int> = listOf()): Boolean {
    if (sequence.size == p && isNotSubsequence(sequence, aArr) && isNotSubsequence(sequence, bArr)) {
        println(p)
        println(sequence.joinToString(" "))
        return true
    }
    if(sequence.size == p) return false
    for (i in 1..k) if (searchAndPrintSequence(p, aArr, bArr, k, sequence + i)) return true
    return false
}

fun isNotSubsequence(sequence: List<Int>, aArr: List<Int>): Boolean {
    if(sequence.size > aArr.size) return false
    var count = 0
    for (i in aArr.indices) {
        if (sequence[count] == aArr[i]) count++
        if (count == sequence.size) return false
    }
    return true
}
