#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <map>
#include <set>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;


ll mod = 998244353;
ll modpow (ll a, ll pow) {
    if (pow == 0) {
        return 1;
    }
    ll c = modpow(a, pow/2);
    return (c*c + a*(pow%2))%mod;

}

ll NOD(ll  a, ll b) {
    if (b == 0) {
        return a;
    }
    return NOD(b, a % b);

}
ll NOK(ll a, ll b) {
    return a*b/NOD(a, b);
}

ll n, k;


signed main() {
//    cin.tie(0);
//    ios_base::sync_with_stdio(false);

    vector<bool> isPrime(1e5, true);
    isPrime[0] = false;
    isPrime[1] = false;
    for (int i = 0; i < sqrt(1e5); ++i) {
        if (isPrime[i]) {
            for (int j = i*i; j < 1e5; j+=i) {
                isPrime[j] = false;
            }
        }
    }

    vector<ll> prime;
    for (int i = 0; i < 1e5; ++i) {
        if (isPrime[i])
            prime.push_back(i);
    }
    ll a, b;
    cin >> a >> b;
    ll counter = 0;
    for (int i = a; i < b; ++i) {
        for (int j = i+1; j < b+1; ++j) {
            ll ab = i*j;
            bool has = false;
            for (auto p: prime) {
                if (p > sqrt(ab)) {
                    break;
                }
                if (ab % (p*p) == 0) {
                    has = true;
                    break;
                }
                if (ab%p == 0) {
                    ab/=p;
                }
            }
            if (!has){
                counter++;
            }
        }
    }
    cout << counter;

    return 0;
}