#include <iostream>
#include <algorithm>
#include <sstream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <unordered_set>
#include <climits>
#include <iomanip>
#include <iterator>
#include <cassert>

#ifndef LOCAL_BUILD
#pragma GCC optimize("-fcaller-saves,-fcrossjumping,-fthread-jumps,-funroll-loops,-fwhole-program,-freorder-blocks")
#pragma GCC optimize("-fpartial-inlining,-freorder-functions,-findirect-inlining,-fhoist-adjacent-loads,-ftree-vrp")
#pragma GCC optimize("-fsched-spec,-falign-jumps,-falign-loops,-falign-labels,-fdevirtualize,move-loop-invariants")
#pragma GCC optimize("-fschedule-insns,-fschedule-insns2,-fstrict-aliasing,-fdelete-null-pointer-checks,-fipa-sra")
#pragma GCC optimize("-fstrict-overflow,-falign-functions,-fcse-skip-blocks,-fcse-follow-jumps,-fsched-interblock")
#pragma GCC optimize("rename-registers,unr1oll-loops,inline-functions,inline-small-functions,vpt,function-sections")
#pragma GCC optimize("-frerun-cse-after-loop,-finline-small-functions,-ftree-switch-conversion,-ftree-tail-merge")
#pragma GCC optimize("-foptimize-sibling-calls,-fexpensive-optimizations,-funsafe-loop-optimizations,-ftree-pre")
#pragma GCC optimize("fast-math,Ofast,inline,no-stack-protector,profile-values,data-sections,-ffast-math,-fgcse")
#pragma GCC optimize("inline-functions-called-once,tracer,profile-reorder-functions,unswitch-loops,-fgcse-lm")
#pragma GCC optimize("branch-target-load-optimize,branch-target-load-optimize2,btr-bb-exclusive,-fpeephole2")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,avx,popcnt,abm,mmx,tune=native")
//#pragma GCC target("avx2")
#pragma warning(disable : 4996)
#define _CRT_SECURE_NO_WARNINGS
#endif

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int INF = 1e9 + 7;
const ld PI = acosl(-1);

#define speed                         \
    ios_base::sync_with_stdio(false); \
    cin.tie(0);                       \
    cout.tie(0)

void solve();
signed main() {
    speed;
    solve();
}

void solve() {
    int l, r;
    cin >> l >> r;
    r++;
    vector<set<int>> nums(r - l);
    vector<bool> isOk(r - l, false);
    for (int a = l; a < r; a++) {
        int m = a;
        bool ok = true;
        for (int del = 2; del <= sqrt(m); del++) {
            while (m != 1 && m % del == 0) {
                m /= del;
                if (nums[a - l].count(del)) {
                    ok = false;
                    break;
                }
                nums[a - l].insert(del);
            }
            if (!ok)
                break;
        }
        if (m != 1) {
            if (nums[a - l].count(m))
                ok = false;
            nums[a - l].insert(m);
        }
        isOk[a - l] = ok;
    }
    ll ans = 0;
    for (int a = l; a < r; a++) {
        if (!isOk[a - l])
            continue;
        for (int b = a + 1; b < r; b++) {
            if (!isOk[b - l])
                continue;
            set<int>* fi = &nums[a - l];
            set<int>* sec = &nums[b - l];
            if (nums[a - l].size() > nums[b - l].size())
                swap(fi, sec);
            bool ok = true;
            for (int e : *fi) {
                if (sec->count(e)) {
                    ok = false;
                    break;
                }
            }
            if (ok)
                ans++;
        }
    }
    cout << ans << "\n";
}