#include <iostream>
#include <algorithm>
#include <sstream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <unordered_set>
#include <climits>
#include <iomanip>
#include <iterator>
#include <cassert>

#ifndef LOCAL_BUILD
#pragma GCC optimize("-fcaller-saves,-fcrossjumping,-fthread-jumps,-funroll-loops,-fwhole-program,-freorder-blocks")
#pragma GCC optimize("-fpartial-inlining,-freorder-functions,-findirect-inlining,-fhoist-adjacent-loads,-ftree-vrp")
#pragma GCC optimize("-fsched-spec,-falign-jumps,-falign-loops,-falign-labels,-fdevirtualize,move-loop-invariants")
#pragma GCC optimize("-fschedule-insns,-fschedule-insns2,-fstrict-aliasing,-fdelete-null-pointer-checks,-fipa-sra")
#pragma GCC optimize("-fstrict-overflow,-falign-functions,-fcse-skip-blocks,-fcse-follow-jumps,-fsched-interblock")
#pragma GCC optimize("rename-registers,unr1oll-loops,inline-functions,inline-small-functions,vpt,function-sections")
#pragma GCC optimize("-frerun-cse-after-loop,-finline-small-functions,-ftree-switch-conversion,-ftree-tail-merge")
#pragma GCC optimize("-foptimize-sibling-calls,-fexpensive-optimizations,-funsafe-loop-optimizations,-ftree-pre")
#pragma GCC optimize("fast-math,Ofast,inline,no-stack-protector,profile-values,data-sections,-ffast-math,-fgcse")
#pragma GCC optimize("inline-functions-called-once,tracer,profile-reorder-functions,unswitch-loops,-fgcse-lm")
#pragma GCC optimize("branch-target-load-optimize,branch-target-load-optimize2,btr-bb-exclusive,-fpeephole2")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,avx,popcnt,abm,mmx,tune=native")
//#pragma GCC target("avx2")
#pragma warning(disable : 4996)
#define _CRT_SECURE_NO_WARNINGS
#endif

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int INF = 1e9 + 7;
const ld PI = acosl(-1);

#define speed                         \
    ios_base::sync_with_stdio(false); \
    cin.tie(0);                       \
    cout.tie(0)

void solve();
signed main() {
    speed;
    solve();
}

int n, k;
int mid = 100;

string myToString (int num, bool addPlus = true) {
    stringstream stream;
    if (addPlus && num >= 0)
        stream << '+';
    stream << num;
    return stream.str();
}

void dfs(int pos, int prev, vector<vector<vector<bool>>>& dp, string built, int sum) {
    if (pos == 0 && sum == 0) {
        cout << built << "\n";
        return;
    } else if (pos == 0)
        return;
    for (int use = prev - 1; use <= prev + 1; use++) {
        if (dp[pos][sum + mid][use + mid] || (pos == 1 && sum - use == 0))
            dfs(pos - 1, use, dp, built + myToString(use), sum - use);
    }
}

void solve() {
    cin >> n >> k;
    vector<vector<vector<bool>>> dp(16, vector<vector<bool>>(200, vector<bool>(40)));
    for (int i = -16; i < 16; i++) {
        dp[1][mid + i][mid + i] = true;
    }
    for (int pos = 2; pos <= k; pos++) {
        for (int i = -16; i < 16; i++) {
            for (int goal = -16; goal < 16; goal++) {
                dp[pos][goal + mid][i + mid] = dp[pos - 1][goal - i + mid][i - 1 + mid] || dp[pos - 1][goal - i + mid][i + mid] || dp[pos - 1][goal - i + mid][i + 1 + mid];
            }
        }
    }

    for (int first = -15; first < 15; first++) {
        if (!dp[k][n + mid][first + mid])
            continue;
        dfs(k - 1, first, dp, myToString(first, false), n - first);
    }
}