#include <iostream>
#include <algorithm>
#include <sstream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <unordered_set>
#include <climits>
#include <iomanip>
#include <iterator>
#include <cassert>

#ifndef LOCAL_BUILD
#pragma GCC optimize("-fcaller-saves,-fcrossjumping,-fthread-jumps,-funroll-loops,-fwhole-program,-freorder-blocks")
#pragma GCC optimize("-fpartial-inlining,-freorder-functions,-findirect-inlining,-fhoist-adjacent-loads,-ftree-vrp")
#pragma GCC optimize("-fsched-spec,-falign-jumps,-falign-loops,-falign-labels,-fdevirtualize,move-loop-invariants")
#pragma GCC optimize("-fschedule-insns,-fschedule-insns2,-fstrict-aliasing,-fdelete-null-pointer-checks,-fipa-sra")
#pragma GCC optimize("-fstrict-overflow,-falign-functions,-fcse-skip-blocks,-fcse-follow-jumps,-fsched-interblock")
#pragma GCC optimize("rename-registers,unr1oll-loops,inline-functions,inline-small-functions,vpt,function-sections")
#pragma GCC optimize("-frerun-cse-after-loop,-finline-small-functions,-ftree-switch-conversion,-ftree-tail-merge")
#pragma GCC optimize("-foptimize-sibling-calls,-fexpensive-optimizations,-funsafe-loop-optimizations,-ftree-pre")
#pragma GCC optimize("fast-math,Ofast,inline,no-stack-protector,profile-values,data-sections,-ffast-math,-fgcse")
#pragma GCC optimize("inline-functions-called-once,tracer,profile-reorder-functions,unswitch-loops,-fgcse-lm")
#pragma GCC optimize("branch-target-load-optimize,branch-target-load-optimize2,btr-bb-exclusive,-fpeephole2")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,avx,popcnt,abm,mmx,tune=native")
//#pragma GCC target("avx2")
#pragma warning(disable : 4996)
#define _CRT_SECURE_NO_WARNINGS
#endif

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int INF = 1e9 + 7;
const ld PI = acosl(-1);

#define speed                         \
    ios_base::sync_with_stdio(false); \
    cin.tie(0);                       \
    cout.tie(0)

void solve();
signed main() {
    speed;
    solve();
}

bool notFound(vector<int>& test, vector<int>& d) {
    map<int, int> cnts;
    for (int e : d)
        cnts[e]++;
    for (int e : test) {
        if (cnts[e] <= 0)
            return true;
        cnts[e]--;
    }
    return false;
}

bool generateAndCheck(int len, int k, vector<int>& a, vector<int>& b, vector<int> cur) {
    if (len == 0) {
        if(notFound(cur, a) && notFound(cur, b)) {
            cout << cur.size() << "\n";
            for (int e : cur)
                cout << e << " ";
            cout << "\n";
            exit(0);
            return true;
        }
        return false;
    }
    for (int i = 1; i <= k; i++) {
        auto ff = cur;
        ff.push_back(i);
        if (generateAndCheck(len - 1, k, a, b, ff))
            return true;
    }
    return false;
}

void solve() {
    int k;
    cin >> k;
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int m;
    cin >> m;
    vector<int> b(m);
    for (int i = 0; i < m; i++)
        cin >> b[i];
    if (k == 1) {
        cout << max(n, m) + 1 << "\n";
        for (int i = 0; i <= max(n, m); i++)
            cout << "1 ";
        cout << "\n";
        return;
    }
    int len = 1;
    while (true) {
        generateAndCheck(len++, k, a, b, {});
    }
}