//
// Created by Vova on 07.12.2020.
//

#include <iostream>
#include <vector>

#include <numeric>
#include <algorithm>
#include <cmath>

using li = int64_t;


std::vector<li> get_prime_numbers_before(li n) {
	// n = std::max(n, 2);
	std::vector<bool> is_prime(n + 2, true);
	is_prime[0] = is_prime[1] = false;

//	for (li i = 2; i * i <= n; ++i)
//		if (is_prime[i])
//			// if (i * i <= n)
//				for (li j = i * i; j <= n; j += i)
//					is_prime[j] = false;

	for(li k = 2; k * k <= n; k++) {
		if(is_prime[k]) {
			for (li l = k * 2; l <= n; l += k){
				is_prime[l] = false;
			}
		}
	}

	std::vector<li> res;
	for (size_t i = 2; i < is_prime.size(); ++i) {
		if(is_prime[i]) res.push_back(i);
	}

	return res;
}

//struct factorization {
//
//};

using factorization = std::vector<std::pair<li, li>>;

factorization factorize_number(li number, std::vector<li>& possible_factors) {
	factorization res;

	for(auto& possible_factor : possible_factors) {
		if (!(number % possible_factor)) {
			res.push_back({ possible_factor, 0LL });

			li this_n = number;
			while(!(this_n % possible_factor)) {
				this_n /= possible_factor;
				res.back().second++;
			}
		}
	}

	return res;
}

bool is_free(li number, const factorization& number_factorization) {
	for (auto& v : number_factorization) {
		if(v.first == number || v.first == 1) {
			continue;
		}
		if (v.second >= 2) {
			return false;
		}
	}

	return true;
}

int main () {
	li l, r;
	std::cin >> l >> r;

	auto sqrt_r = size_t(std::sqrt(r) + 3);

	auto primes = get_prime_numbers_before(sqrt_r);

//	std::vector<li> possible_factors;
//	possible_factors.reserve(primes.size() * 2);
//	for(auto& p : primes) {
//		possible_factors.push_back()
//	}

	std::vector<std::pair<li, factorization>> factorizations;

	for (li this_number = l; this_number <= r; ++this_number) {
		factorizations.emplace_back( this_number, factorize_number(this_number, primes));
	}

	std::vector<bool> are_free;

	for(const auto& f : factorizations) {
		are_free.push_back(is_free(f.first, f.second));
	}


	li count = 0;
	for (size_t i = 0; i < factorizations.size(); ++i) {
		if(!are_free[i]) continue;

		for (size_t j = i + 1; j < factorizations.size(); ++j) {
			if(!are_free[j]) continue;

			li a = factorizations[i].first;
			li b = factorizations[j].first;

			li ab = a * b;
			auto ab_fact = factorize_number(ab, primes);
			if(is_free(ab, ab_fact)) count++;
		}
	}

	std::cout << count << std::endl;

	// for(auto& p1: primes) std::cout << p1 << " ";

	return 0;
}
