//
// Created by Vova on 07.12.2020.
//


#include <iostream>
#include <vector>

#include <numeric>
#include <algorithm>

using li = int64_t;

struct perm_with_sum
{
	std::vector<li> perm;
	li sum;
};

void generate_series_impl(std::vector<perm_with_sum>& container, li n, std::vector<li>& current_permutation, li current_sum) {
	if(current_permutation.size() == n) {
		container.push_back({ current_permutation, current_sum });
		return;
	}

	// Add either +, or - of 0 element:
	current_permutation.push_back(current_permutation.back());
	generate_series_impl(container, n, current_permutation, current_sum + current_permutation.back());

	current_permutation.back() -= 1;
	generate_series_impl(container, n, current_permutation, current_sum + current_permutation.back());

	current_permutation.back() += 2;
	generate_series_impl(container, n, current_permutation, current_sum + current_permutation.back());

	current_permutation.pop_back();
}

std::vector<perm_with_sum> generate_series(li n) {
	std::vector<perm_with_sum> container;
	container.reserve(li(pow(3, n - 1)));

	std::vector<li> current_perm = { 0 };
	generate_series_impl(container, n, current_perm, 0);

	return container;
}

int main() {

	li n, k;
	std::cin >> n >> k;

	auto series = generate_series(k);
	// std::cout << series.size() << std::endl;

	std::vector<std::vector<li>> res;
	// res.reserve();

	for (auto& s : series) {
		if (!(std::abs(s.sum - n) % k)) {
			li first_element;
			// if(s.sum - n > 0) {
				first_element = (n - s.sum) / k;
			// }


			// std::cout << std::accumulate(s);
			res.emplace_back();
			res.back().reserve(s.perm.size());
			for(auto &el : s.perm) {
				// std::cout << el + first_element << " ";
				res.back().push_back(el + first_element);
			}

			// std::cout << std::endl;
		}
	}

	std::sort(res.begin(), res.end());

	for(auto& r : res) {
		bool is_first = true;
		for(auto& v : r) {
			if (!is_first && v >= 0) std::cout << "+";
			std::cout << v;
			is_first = false;
		}
		std::cout << "\n";
	}

//
//	for(auto & r : series) {
//		std::cout << r.sum << " | ";
//		for(auto& el : r.perm) {
//			std::cout << el << " ";
//		}
//		std::cout << std::endl;
//	}

	return 0;
}