﻿#pragma GCC optimize("O2")

#pragma region
#include <iostream>
#include <vector>
#include <utility>
#include <cmath>
#include <ctime>
#include <string>
#include <stack>
#include <algorithm>
#include <map>
#include <list>
#include <cassert>
#include <iomanip>
#include <set>
#include <queue>
#include <deque>
#include <unordered_set>

using namespace std;
#define ll long long
#define ld long double
#define int long long
#define VI vector<int>
#define VVI vector<VI>
#define VD vector<double>
#define VS vector<string>
#define VC vector<char>
#define VB vector<bool>
#define PAR pair<int, int>
#define VP vector<PAR>
#define SI set<int>
#define QI queue<int>
#define DI deque<int>
#define SP set<PAR>
#define QP queue<PAR>
#define DP deque<PAR>
#define SS set<string>
#define vall(x) x.begin(), x.end()
#define INF (int)(1e9 + 7)
#define BIGINF (ll)(1e18)
#define endl '\n'

void print(const VI& v) {
    for (auto val : v) {
        cout << val << ' ';
    }
    cout << endl;
}

void print(const VB& v) {
    for (auto val : v) {
        cout << val << ' ';
    }
    cout << endl;
}

bool rmax(int& a, int b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

bool rmin(int& a, int b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
#pragma endregion

set<int> factor(int n) {
    set<int> res;
    int d = 2;
    while (n > 1 && d*d <= n) {
        if (n % d == 0) {
            res.insert(d);
            n /= d;
        }
        ++d;
    }
    if (n > 1) {
        res.insert(n);
    }
    return res;
}

bool is_prime(int n) {
    int d = 2;
    while (d * d <= n) {
        if (n % d == 0)
            return false;
        ++d;
    }
    return true;
}



signed main() {
    int l, r;
    cin >> l >> r;
    vector<set<int>> factnums;
    /*bool good = true;
    for (int num = l; num <= r; ++num) {
        set<int> s = factor(num, good);
        if (good) {
            nums.push_back(s);
        }
    }

    cout << "1" << endl;*/
    set<int> nums;

    for (int i = l; i <= r; ++i)
        nums.insert(i);

    for (int d = 2; d * d <= r; ++d) {
        if (is_prime(d)) {
            for (int n = l; n <= r; ++n) {
                if (n % d == 0 && (n / d) % d == 0)
                    nums.erase(n);
            }
        }
    }

    for (int n : nums) {
        factnums.push_back(factor(n));
    }

    int cnt = 0;
    for (int i = 0; i < factnums.size(); ++i) {
        for (int j = 0; j < factnums.size(); ++j) {
            const set<int>& a = factnums[i];
            const set<int>& b = factnums[j];
            bool bad = false;
            for (int p : a) {
                if (b.find(p) != b.end()) {
                    bad = true;
                    break;
                }
            }
            if (!bad)
                ++cnt;
        }
    }

    cout << (cnt / 2) << endl;
    return 0;
}
