#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;

#define MULTITASK ELT
typedef long long ll;
typedef vector<int> vi;


vi factorize(int n) {
  vi result;
  int r = sqrt(n) + 1;
  for(int d = 2; d < r; d++) {
    while (n % d == 0) {
      result.push_back(d);
      n /= d;
    }
    if (n == 1) {
      return result;
    }
  }
  result.push_back(n);
  return result;
}


inline bool check(const vi& a, const vi& b) {
  auto i = a.begin();
  auto j = b.begin();
  while (i < a.end() && j < b.end()) {
    auto i1 = i;
    auto j1 = j;
    if (*i < *j) {
      i++;
      if (i < a.end() && *i1 == *i) {
        return false;
      }
    } else if (*i > *j) {
      j++;
      if (j < b.end() && *j1 == *j) {
        return false;
      }
    } else {
      return false;
    }
  }
  while (i < a.end()) {
    auto i1 = i;
    auto j1 = j;
      i++;
      if (i < a.end() && *i1 == *i) {
        return false;
      }
  }
  
  while (j < b.end()) {
    auto i1 = i;
    auto j1 = j;
      j++;
      if (j < b.end() && *j1 == *j) {
        return false;
      }
  }
  return true;
}


void solve() {
  int l, r; cin >> l >> r; r++;
  vector<vi> a(r - l);
  for (int i = l; i < r; i++)
  {
    a[i - l] = factorize(i);
    //  for (int e : a[i - l])
    // {
    //    cout << e << " ";
    //  }
    // cout << "\n";
  }

  int res = 0;
  for (int i = l; i < r; i++) {
    for (int j = i + 1; j < r; j++) {
      bool b = check(a[i - l], a[j - l]);
      res += b;
       if (b)
       cout << i << " " << j << endl;
    }
  }
  cout << res << "\n";
}

int main() {
#if ELT
   freopen("input.txt", "r", stdin);
#endif
#if MULTITASK
   int q; cin >> q;
   while(q--) {
     solve();
   }
#else
   solve();
#endif
}
