#include <iostream>
#include <string>
#include <cmath>

using namespace std;

typedef long long llong;

bool isFree( llong a )
{
  const llong upper = sqrt(sqrt(a) + 1) + 1;
  for (llong i = 2, ii = i * i; i <= upper; ++i, ii += i + i - 1)
    if (a % ii == 0)
      return false;
  return true;
}

int main( void )
{
  std::ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

  llong l, r, ans = 0; cin >> l >> r;
  for (llong b = l + 1; b <= r; ++b)
    for (llong a = l; a < b; ++a)
      ans += isFree(a) && isFree(b) && isFree(a * b);

  cout << ans << '\n';
  return 0;
}

/*
b.cpp - main
-------
  int a, b, k; cin >> a >> b >> k;
  int a1 = (a - 1) * a / 2;

  while (a <= b)
  {
    if (a <= k)
      for (int i = 0; i < a; ++i)
        cout << ++a1 << ' ';
    else
    {
      for (int i = 0; i < k; ++i)
        cout << ++a1 << ' ';
      a1 += a - k;
    }
    ++a;
    cout << '\n';
  }
*/
