#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long llong;

/*
llong n, k;
vector<int> ans;
vector<char> symb;

  cin >> n >> k;
  ans.resize(k); symb.resize(k);
  for (int i = -n - k; i < n + k; ++i)
    rec(0, i, 0);

void rec(int sum, int last, int len)
{
  if (len == k)
  {
    if (sum == n)
    {
      for (int i = 0; i < k; ++i)
        cout << symb[i] << abs(ans[i]);
      cout << '\n';
    }
    return;
  }
  ans[len] = last - 1; symb[len] = '-';
  rec(sum + last - 1, last - 1, len + 1);
  ans[len] = last ; symb[len] = '+';
  rec(sum + last, last, len + 1);
  ans[len] = last + 1; symb[len] = '+';
  rec(sum + last + 1, last + 1, len + 1);
}
*/

bool isFree( llong a )
{
  const llong upper = sqrt(a);
  for (llong i = 2, ip2 = 4; ip2 <= upper; ++i, ip2 += i + i - 1)
    if (a % ip2 == 0)
      return false;
  return true;
}

llong getMD( llong a, llong b )
{
  while (a != 0 && b != 0)
    if (a > b)
      a %= b;
    else
      b %= a;
  return a + b;
}

int main( void )
{
  llong l, r, ans = 0; cin >> l >> r;
  for (llong b = l + 1; b <= r; ++b)
    if (isFree(b))
      for (llong a = l; a < b; ++a)
        ans += isFree(a) && getMD(a, b) == 1;

  cout << ans << '\n';
  return 0;
}

/*
f.cc[[


  std::ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

  int k, m, n; cin >> k;
  cin >> m; vector<int> a(m);
  for (auto &e : a) cin >> e;
  cin >> n; vector<int> b(n);
  for (auto &e : b) cin >> e;

  if (k = 1)
  {
    const int mm = max(m, n) + 1;
    cout << mm << '\n';
    for (int i = 1; i < mm; ++i)
      cout << "1 ";
    cout << "1\n";
  }
*/
