#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

bool gen(int k, int n, vector<int> &ans, const vector<int> &a, const vector<int> &b) {
  if (ans.size() == n) {
    {
      int i = 0, j = 0;
      while (i < ans.size() && j < a.size()) {
        if (ans[i] == a[j]) i++, j++;
        else j++;
      }
      if (i == ans.size()) return 0;
    }
    {
      int i = 0, j = 0;
      while (i < ans.size() && j < b.size()) {
        if (ans[i] == b[j]) i++, j++;
        else j++;
      }
      if (i == ans.size()) return 0;
    }

    return 1;
  }

  for (int i = 1; i <= k; ++i) {
    ans.push_back(i);
    if (gen(k, n, ans, a, b)) return 1;
    ans.pop_back();
  }

  return 0;
}

int main()
{
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int n, k, m;
  cin >> k;
  cin >> n;
  vector<int> a(n);
  for (auto &i : a) cin >> i;
  cin >> m;
  vector<int> b(m);
  for (auto &i : b) cin >> i;

  int left = 1, right = max(n, m) + 1;
  while (right > left) {
    int mid = (left + right) >> 1;
    vector<int> ans;
    if (gen(k, mid, ans, a, b)) right = mid;
    else left = mid + 1;
  }

  vector<int> ans;
  gen(k, left, ans, a, b);
  cout << left << '\n';
  for (auto i : ans) cout << i << ' ';
  cout << '\n';
}