#include <iostream>
#include <math.h>
#include <minmax.h>
#include <string>
#include <vector>
using namespace std;

int* parts;

struct node {
    int value;
    vector<node*> children;
    
    node(int val) {
        this->value = val;
        this->children = vector<node*>();
    }

    bool add(int a) {
        node* cur = this;
        bool exists = true;
        for (int i = 0; i < a; i++) {
            int p = parts[i];
            bool found = false;
            for (auto n : cur->children) {
                if (n->value == p) {
                    found = true;
                    cur = n;
                    break;
                }
            }

            if (!found) {
                exists = false;
                node* n = new node(p);
                cur->children.push_back(n);
                cur = n;
            }
        }
        return exists;
    }
};

void print_parts(int a) {
    int sum = 0;
    for (int i = 0; i < a; i++) {
        int part = parts[i];
        if (part >= 0 && i) {
            cout << "+";
        }
        cout << part;
        sum += part;
    }

    //cout << "=" << sum;
    cout << endl;
}

void calc(node* n, int num, int i, int c, int a, int cur_sum) {
    if (c == a ) {
        if (cur_sum == num) {
            if (!n->add(a)) {
                print_parts(a);
            }
        }
        return;
    }
    parts[c] = i;
    calc(n, num, i - 1, c + 1, a, cur_sum + i);
    calc(n, num, i, c + 1, a, cur_sum + i);
    calc(n, num, i + 1, c + 1, a, cur_sum + i);
}

int main()
{
    int num, amount;
    cin >> num;
    cin >> amount;
    parts = new int[amount];
    if (num < 0) {
        for (int i = num; i < -num + 1; i++) {
            node* n = new node(i);
            calc(n, num, i, 0, amount, 0);
        }
    }
    else {
        for (int i = -num; i < num + 1; i++) {
            node* n = new node(i);
            calc(n, num, i, 0, amount, 0);
        }
    }
    
} 
