#include <iostream>
#include <cmath>
#include <vector>
using namespace std;

vector<int> FirstMrt(int n) 
{
	int start = n;
	vector<int> result;
	for (int i = 2; i <= sqrt(n); ++i) 
	{
		int count = 0;
		while (n % i == 0) 
		{
			++count;
			n /= i;
			if (count >= 2)
			{
				result.clear();
				return result;
			}
		}
		if (count == 1)
		{
			result.push_back(i);
			result.push_back(start / i);
		}
	}
	result.push_back(n);
	return result;
}

bool CheckSubjects(vector<int> arr1, vector<int> arr2) 
{
	for (int i = 0; i < arr1.size(); ++i) 
	{
		for (int j = 0; j < arr2.size(); ++j)
			if (arr1[i] == arr2[j])
				return true;
	}
	return false;
}

int main() 
{
	int l, r;
	cin >> l >> r;
	vector<vector<int>> data;
	for (int i = l; i <= r; ++i)
	{
		vector<int> current = FirstMrt(i);
		if (current.size() != 0)
			data.push_back(current);
	}
	int count = 0;
	for (int i = 0; i < data.size(); ++i)
		for (int j = i + 1; j < data.size(); ++j) 
		{
			if (!CheckSubjects(data[i], data[j]))
				++count;
		}
	cout << count;
	return 0;
}