#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#define int long long
using namespace std;

const int maxn = 1e5;

bool used[maxn + 5];

set <int> q;

vector <int> p;

void sieve()
{
	for (int i = 2; i < maxn; i++)
	{
		if (!used[i])
		{
			for (int j = i; j < maxn; j += i)
				used[j] = true;
			p.push_back(i);
		}
	}
}

bool check(int x)
{
	int idx = 0, cnt = 0;
	while (x != 1)
	{
		int d = p[idx];
		if (x % d == 0)
			x /= d, cnt++;
		else
			idx++, cnt = 0;
		if (cnt >= 2)
			return false;
	}
	return true;
}

int32_t main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	sieve();
	int l, r, ans = 0;
	cin >> l >> r;
	for (int i = l; i <= r; i++)
		if (!check(i))
			q.insert(i);
	for (int i = l; i <= r; i++)
	{
		if (q.count(i))
			continue;
		for (int j = i + 1; j <= r; j++)
		{
			if (q.count(j))
				continue;
			if (__gcd(i, j) != 1)
				continue;
			ans++;
		}
	}
	cout << ans;
}