#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>

using namespace std;

template <class T = int>
T next() { T x; cin >> x; return x; }

struct tless
{
    bool operator()(const vector<int>& t1, const vector<int>& t2) const
    {
        for (int i = 1; i < t1.size(); i++)
            if (t1[i] != t2[i])
                return t1[i] < t2[i];

        return false;
    }
};

set<vector<int>, tless> answers;
vector<int> solution;

void solve(int n, int k)
{
    //cout << n << ' ' << k << '\n';

    if (k == 0)
    {
        if (n == 0)
            answers.insert(solution);

        return;
    }

    for (int i = solution.back() - 1; i <= solution.back() + 1; i++)
    {
        solution.push_back(i);
        solve(n - i, k - 1);
        solution.pop_back();
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, k;
    cin >> n >> k;
    solution.reserve(k);

    for (int i = -15; i <= 15; i++)
    {
        solution.push_back(i);
        solve(n, k);
        solution.pop_back();
    }

    for (vector<int> sol : answers)
    {
        cout << sol[1];

        for (int i = 2; i < sol.size(); i++)
            if (sol[i] < 0)
                cout << sol[i];
            else
                cout << '+' << sol[i];

        cout << '\n';
    }

    return 0;
}
